﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ScheduleMountain
{
    public class Fixtures
    {
        public Fixtures()
        {
            try
            {
                this.ID = DateTime.Now.Millisecond;
                this.firstDay = new DateTime(2014, 8, 20, 13, 30, 0);
                this.lastDay = new DateTime(2015, 5, 8, 13, 30, 0);
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.Message);
            }
        }

        public DateTime StartDateTimeUTC
        {
            get
            {
                return this.GameDate.ToUniversalTime();
            }
            set
            {
                ;
            }
        }

        public DateTime OriginalStartDateTimeUtc
        {
            get
            {
                return this.GameDate.ToUniversalTime();
            }
            set
            {
                ;
            }
        }

        public int Duration { get { return this.GameDuration; } set { this.GameDuration = value; } }

        public DateTime GameDate { get; set; }
        public string HomeTeam { get; set; }
        public string Visitors { get; set; }
        public int GameDuration { get; set; }

        public int ID { get; set; }

        public string Name // aka Subhect
        {
            get { return this.Visitors + " @ " + this.HomeTeam; }
        }

        public string Subject
        {
            get { return Name; }
        }

        public bool AllDayEvent
        {
            get { return true; }
            set
            {
                ;
            }
        }

        private string _location = string.Empty;
        public string Location
        {
            get
            {
                if (this._location == string.Empty && this.HomeTeam != string.Empty && Fixtures.Stadiums.ContainsKey(this.HomeTeam))
                {
                    this._location = Fixtures.Stadiums[this.HomeTeam];
                }
                return this._location;
            }
        }

        public string ActivityDescription
        {
            get { return this.Name;  }
        }

        public int Status
        {
            get
            {
                return (int) Infragistics.WebUI.WebSchedule.ActivityStatus.Normal;
            }
        }

        public bool EnableReminders { get { return true; } }

        public Infragistics.WebUI.WebSchedule.ShowTimeAs ShowTimeAs { get; set; }

        public int Importance { get { return 1; } }

        public int ResourceID { get { return 2; } }

        public string ResourceName { get { return "2"; } }

        public int RecurrenceID { get { return 0;  } }

        public string RecurrencePattern { get { return ""; } }

        public int ReminderInterval { get { return 0;  } }



        public string VarianceID { get { return Guid.NewGuid().ToString(); } }

        public static string[] Teams = new string[] {
            "Chelsea",
            "Arsenal",
            "Manchester City",
            "Manchester United",
            "Liverpool",
            "Tottenham Hotspur",
            "Southampton",
            "Newcastle United",
            "Everton",
            "West Ham United",
            "Swansea City",
            "West Bromwich Albion",
            "Hull City",
            "Leicester City",
            "Crystal Palace",
            "Queens Park Rangers",
            "Burnley",
            "Sunderland",
            "Stoke City",
            "Aston Villa"
        };

        public static Dictionary<string, string> Stadiums = new Dictionary<string, string>()
        {
            { "Chelsea", "Stamford Bridge"},
            { "Arsenal", "The Emirates"},
            { "Manchester City", "The Etihad"},
            { "Manchester United", "Old Trafford"},
            { "Liverpool", "Anfield"},
            { "Tottenham Hotspur", "White Hart Lane"},
            { "Southampton", "St. Marys"},
            { "Newcastle United", "St. James' Park"},
            { "Everton", "Goodison Park"},
            { "West Ham United", "The Boleyn Ground"},
            { "Swansea City", "Liberty Stadium"},
            { "West Bromwich Albion", "The Hawthorns"},
            { "Hull City", "KC Stadium"},
            { "Leicester City", "King Power Stadium"},
            { "Crystal Palace", "Selhurst Park"},
            { "Queens Park Rangers", "Loftus Road"},
            { "Burnley", "Turf Moor"},
            { "Sunderland", "Stadium of Light"},
            { "Stoke City", "Britannia"},
            { "Aston Villa", "Villa Park"}
        };

        //public List<Fixtures> TheFixtures;

        public List<Fixtures> GenerateFixtures()
        {
            Random r = new Random();
            int hTeam;
            int vTeam;
            List<Fixtures> season = new List<Fixtures>();
            Fixtures f;
            for (int a = 1; a <= 40; ++a)
            {
                hTeam = r.Next(0, 19);
                vTeam = r.Next(0, 19);
                while (hTeam == vTeam)
                {
                    vTeam = r.Next(0, 19);
                }


                f = new Fixtures();
                f.GameDuration = 145;
                f.HomeTeam = Fixtures.Teams[hTeam];
                f.Visitors = Fixtures.Teams[vTeam];
                f.GameDate = f.GetGameDate();

                season.Add(f);
            }
            return season;
        }

        private DateTime firstDay;
        private DateTime lastDay;
        private TimeSpan seasonSpan;

        private DateTime GetGameDate()
        {
            this.seasonSpan = this.lastDay.Subtract(firstDay);

            Random r = new Random();
            int dayPick = r.Next(0, this.seasonSpan.Days - 1);
            DateTime gameDate = this.firstDay.AddDays(dayPick);

            return gameDate;
        }
    }
}